! mesh generator for various 3 dimensional trusses and frames
! 
      SUBROUTINE GENERATE_3D_TRUSS_1
      USE COMMON_ALLOCATE
      USE FILE_USE
      USE BIG_FRAME_PARAMETERS
      INTEGER :: NA,NA1,NA2,NA3, &   
                 NR,NR1,NR2,NR3, &
                 NC,NC1,NC2,NC3
      INTEGER :: NBAYS(3)
      CALL LOCATE(M1,NA,NR,NC)
      CALL FREEI('N',NBAYS,3)
      CALL FREEH('T',BIGTYPE,4,1)
      CALL SET_PARAMETERS(BIGTYPE,NDF,IDF,NCN,ITYPE,TEST)
      SELECT CASE(ITYPE)
      CASE(3)
      WRITE(NDG,*) ' THREE DIMENSION TRUSS MESH GENERATION'
      CASE(4)
      WRITE(NDG,*) ' THREE DIMENSION FRAME MESH GENERATION'
      END SELECT
      CALL LOCATE(M2,NA3,NR3,NC3)
      NR1=NBAYS(2)*(NBAYS(1)+1)
      NC1=3
      NJNTS=NR1
      CALL DELETE('XYZ$')
      CALL DEFINE('XYZ$',NA1,NR1,NC1)
      NR2=NBAYS(2)*3*NBAYS(1)+nbays(2)
      NC2=nc3
      NMBS=NR2
      CALL DELETE('PR$$')
      CALL DEFINE('PR$$',NA2,NR2,NC2)
      CALL GEN_MESH_3D1(JA(NA),JA(NA1),JA(NA2),JA(NA3),NR1,NR2,NC1,NC2,NC3,NBAYS(1),NBAYS(2),NBAYS(3))
      RETURN
      END  SUBROUTINE GENERATE_3D_TRUSS_1

! SUBROUTINE TO GENERATE 3D MESH OF TRIANGULAR CROSS SECTION WITH PARALLEL CHORDS
      SUBROUTINE GEN_MESH_3D1(DIMEN,XYZ,NP_DATA,MEMB,NJNTS,NMBS,NC1,NC2,NC3,NBAYS,NFACE,NP)
      USE FILE_USE
      REAL, INTENT(IN) :: DIMEN(5),MEMB(NP,nc3)
      REAL,INTENT(OUT) :: XYZ(NJNTS,NC1)
      REAL,INTENT(OUT) :: NP_DATA(NMBS,NC2)
  !,PROPERTIES(NMAT,NC3)
 !     INTEGER,INTENT(IN) :: NBC(NBPTS,NC2),N_LOADS(NP)
      REAL :: YTOP,YBOT,ZLEFT,ZRIGHT,LENGTH,DL,XCOORD
      INTEGER :: I,J,K,MN,KS,KF,KS1,KF1,NBAYS,NFACE,NL,NC1,NC2,NC3,NP,KFORMAT
      integer ::iperm(nface)
      do I=2,nface
      iperm(i-1)=i
      end do
      iperm(nface)=1
      write(nt7,*) 'iperm',iperm
      DL=DIMEN(5)/REAL(NBAYS)
      WRITE(NT7,*) 'DL,DIMEN(5)',DL,DIMEN(5),NBAYS,NJNTS
      YTOP=DIMEN(1)
      YBOT=DIMEN(2)
      ZLEFT=DIMEN(3)
      ZRIGHT=DIMEN(4)
! GENERATE ALL THE NODE COORDINATES
      XCOORD=0.0
      DO I = 0,NBAYS*NFACE,NFACE
      WRITE(NT7,*) 'DL--',DL
       WRITE(NT7,*) 'i-XCOORD',I,XCOORD
        XYZ(I+1:I+NFACE,1)=XCOORD
        XYZ(I+1:I+2,2)=YTOP
        XYZ(I+3:I+NFACE,2)=YBOT
        SELECT CASE (NFACE)
        CASE (3)
        XYZ(I+1,3)=ZLEFT
        XYZ(I+2:I+3,3)=ZRIGHT
        CASE(4)
        XYZ(I+2:I+3,3)=ZRIGHT
        XYZ(I+1:I+NFACE:NFACE-1,3)=ZLEFT
        END SELECT
         XCOORD=DL+XCOORD
       WRITE(NT7,*) 'i-XCOORD',I,XCOORD
      END DO
     WRITE(NDG,100) ((XYZ(I,J),J=1,3),I=1,NJNTS)
 100 FORMAT(3F10.2)
       
! MEMBER NODE NUMBERS 
! 1) TOP LONGITUDINAL MEMBERS AND BOTTOM CHORD
!
      MN=0
      DO I=1,NFACE
       DO J=1,NBAYS
        KS=I+(J-1)*NFACE
        MN=MN+1
        NP_DATA(MN,1)=REAL(KS)
        NP_DATA(MN,2)=REAL(KS+NFACE)
       END DO
      END DO
    WRITE(NDG,102) ((NP_DATA(I,J),J=1,2),I=1,MN)
 102 FORMAT(1X,2F12.0)
! MEMBER NODE NUMBERS 
! 2) TRANSVERSE MEMBERS
     DO I=1, NFACE
      KS=I
      KF=IPERM(I)
      DO J=0,NBAYS
       MN=MN+1
       KS1=KS+NFACE*J
       KF1=KF+NFACE*J
       NP_DATA(MN,1)=REAL(KS1)
       NP_DATA(MN,2)=REAL(KF1)
      END DO
     END DO
    WRITE(NDG,102)((NP_DATA(I,J),J=1,2),I=1,MN)
 !   if(nface <=4) return
! MEMBER NODE NUMBERS
! 3) DIAGONAL MEMBERS
      DO I=1, NFACE
       KS=I
       KF=IPERM(I)+NFACE
       DO J=1,NBAYS
        MN=MN+1
        KS1=KS+NFACE*(J-1)
        KF1=KF+NFACE*(J-1)
        NP_DATA(MN,1)=REAL(KS1)
        NP_DATA(MN,2)=REAL(KF1)
       END DO
     END DO
!     IF(NFACE <= 4) RETURN
   !    DO I=1,NMBS
 !    write(NDG,101)I,(NP_DATA(I,J),J=1,2)
  !   END DO
 101 FORMAT(1X,I5,2F10.0)
  ! now fill out property values
     DO I=1,NP
       DO J=INT(MEMB(I,1)),INT(MEMB(I,2)),1
        NP_DATA(J,3:nc3)=MEMB(I,3:nc3)
  !  write(ndg,114) memb(i,3),np_data(j,3),j,i
 !114  format(1x,2f10.1,2i5)
       END DO
     END DO
     WRITE(NDG,*) 'NC3',NC3
     select case(nc3)
     case(3)
     write(ndg,113)((REAL(I),(NP_DATA(I,J),J=1,2),NP_DATA(I,NC3)),I=1,NMBS)
     case(5)
     write(ndg,114)((REAL(I),(NP_DATA(I,J),J=1,2),NP_DATA(I,K),K=3,NC3),I=1,NMBS)
     end select
 113 format(1X,3F5.0,F10.2)
 114 FORMAT(1X,3F5.0,5F10.2)
     RETURN
     END SUBROUTINE GEN_MESH_3D1


      

