     SUBROUTINE BIG_FRAME
     USE BIG_FRAME_PARAMETERS
     USE FILE_USE
     USE COMMON_ALLOCATE
     INTEGER :: NA0,&
                NA,NA1,NA2,NA3,NA4,NA5,NA6, &
                NR,NR1,NR2,NR3,NR4,NR5, &
                NC,NC1,NC2,NC3,NC4,NC5 
     ! ......
! this set of subroutines uses and incore solver to calculate 
! structure deflections and mEmber forces for large size problems
! on mini computer using "Spanish Equation Solver,
!  see program BigFrame for more details.
! PUT FILE NUMBERS IN IOSET
     CALL SET_FILES_BIG_FRAME
     CALL DELETE('EQNS')
     CALL DEFINE('EQNS',NA0,BLKSTR,1)
     CALL LOCATE(M1,NA,NR,NC) ! coordinates
     CALL LOCATE(M2,NA1,NR1,NC1) ! topology and properties
     CALL LOCATE(M3,NA2,NR2,NC2) ! support specifications
     CALL FREEH('T',BIGTYPE,5,1)   ! structure type
     CALL LOCATE(M4,NA3,NR3,NC3) ! material properties, young's modulus, poisson's ratio
     CALL LOCATE(M5,NA4,NR4,NC4) ! number of loaded nodes in each load case 
! set up internal parameters for each structure type
     CALL SET_PARAMETERS(BIGTYPE,NDF,IDF,NCN,ITYPE,TEST) 
     WRITE(NDG,*) BIGTYPE,NDF,ITYPE
     NJNTS=NR
     NMBS=NR1
     NBPTS=NR2
     NMAT=NR3
     NHIP=NC4
     CALL SETUP(JA(NA),JA(NA1),IA(NA2),JA(NA3),IA(NA4),NJNTS,NMBS,NBPTS,NMAT,NHIP, &
                 NC,NCN,NDF,NC1,NC2,NR3,NC3,NC4,ITYPE)
  !  XYZ,NP_DATA,NBC,PROPERTIES,N_LOADS,NJNTS,NMBS,NBPTS,NMAT,NHIP, &
 !                     NC,NCN,NDF, NC1,NC2,NC3,NR3,NC4,ITYPE)
      CALL DELETE('ID$$')
      CALL DEFINE('ID$$',NA5,NJNTS,NDF)
! RETURNS active DOF in ID AND neq=NO OF EQUATIONS
      CALL SETID(IA(NA5),IA(NA2),NJNTS,NDF,NBPTS,NC2,NEQ) 
      CALL STFGEN(JA(NA),JA(NA1),JA(NA3),IA(NA5), &
                   NJNTS,NC,NMBS,NDF,NCN,NC1,NMAT,NC3,MBAND,ITYPE)
      CALL SETBLO (IA(NA5),JA(NA1),NRECO,MBAND,MTOT,NHIP,NEQ,NMBS,NDF &
                  ,NEQB,NE2B,NDBL,NJNTS,NCN,NC1)
       CALL SPLIT(MBAND,NHIP,NEQ,NF1,NF2,NBUF)
      CALL LOCATE('L$$$ ',NA6,NR5,NC5)
      CALL LODGEN(IA(NA5),JA(NA6),IA(NA4),NDF,NEQ,ITYPE,NJNTS,NHIP,NDBL,NEQB,NE2B,NC4,NR5,NC5)
      CALL STFADD(JA(NA0),BLKSTR,NMBS,NJNTS,NHIP,NDF,NDBL,NE2B,MBAND,NEQ,NCN) 
        CALL TRIAN(NEQ,MBAND,NHIP,BLKSTR,ITIME,JA(NA0))
     CALL BACKS(NEQ,MBAND,NHIP,BLKSTR,JA(NA0))
 2001 FORMAT(1X,'END BIGMAIN AFTER BACKS')
    CALL PRINT_DISPLACEMENTS(JA(NA0),IA(NA2),BLKSTR,NJNTS,NBPTS,NC2,NDF,NCN,ITYPE,NMBS,NHIP,NEQ)
       CALL SET_I_FORCE(ITYPE,IB)
     CALL STRCAL(JA(NA),JA(NA1),JA(NA3),IA(NA5), &
            NJNTS,NC,NMBS,NDF,NCN,NC1,NMAT,NC3,NHIP,ITYPE,IB)

     RETURN
     END SUBROUTINE BIG_FRAME
 
!
!C       SOLVE EQUATIONS USING RECUERO GUTIERREZ ALGORITHM
!C       SEE INTERNATIONAL JOURNAL NUM. NETHODS
!C       VOL 14,633-645(1979)
!
!
       SUBROUTINE SET_FILES_BIG_FRAME
      USE FILE_USE
      NF1=21
      NF2=22
      NF3=23
      NF4=24
      NF5=25
      NF6=26
      NF7=27
      NF8=28
      OPEN(UNIT=NF1,STATUS='SCRATCH',ACCESS='DIRECT',RECL=512)
      OPEN(UNIT=NF2,STATUS='SCRATCH',ACCESS='DIRECT',RECL=512)
      OPEN(UNIT=NF3,STATUS='SCRATCH',ACCESS='DIRECT',RECL=72*NSIZ)
      OPEN(UNIT=NF4,STATUS='SCRATCH',ACCESS='DIRECT',RECL=12*4)
      OPEN(UNIT=NF5,STATUS='SCRATCH',FORM='UNFORMATTED')
      OPEN(UNIT=NF6,STATUS='SCRATCH',FORM='UNFORMATTED')
      OPEN(UNIT=NF7,STATUS='SCRATCH',FORM='UNFORMATTED')
      OPEN(UNIT=NF8,STATUS='SCRATCH',FORM='UNFORMATTED')
      RETURN
      END subroutine set_files_big_frame
